﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System.Threading;

namespace _93643
{
    public partial class Form1 : Form
    {
        DataSet ds;

        BindingList<DataObject> dataObjects;

        static Infragistics.Win.Appearance appDef = new Infragistics.Win.Appearance();
        static Infragistics.Win.Appearance appMod3 = new Infragistics.Win.Appearance();
        static Infragistics.Win.Appearance appMod4 = new Infragistics.Win.Appearance();
        static Infragistics.Win.Appearance appMod5 = new Infragistics.Win.Appearance();

        

        public Form1()
        {
            InitializeComponent();

            
           
        }


        private void Form1_Load(object sender, EventArgs e)
        {
            appDef.BackColor = Color.Azure;
            appMod3.BackColor = Color.Yellow;
            appMod4.BackColor = Color.Green;
            appMod5.BackColor = Color.Orange;
            ultraGrid1.DisplayLayout.MaxBandDepth = 3;
        }

        private DataSet GetData()
        {
            DataTable tableTop = new DataTable("tableTop");
            tableTop.Columns.Add("TopTableID", typeof(int)).AutoIncrement = true;
            tableTop.PrimaryKey = new DataColumn[] { tableTop.Columns["TopTableID"] };
            tableTop.Columns.Add("IntegerColumn", typeof(int));
            tableTop.Columns.Add("Flags", typeof(WarningFlag));
            for (int i = 0; i < 7; i++)
            {
                tableTop.Columns.Add(string.Format("StringColumn{0}", i), typeof(string)).DefaultValue = "tableTop";
            }

            DataTable tableMiddle = new DataTable("tableMiddle");
            
            tableMiddle.Columns.Add("MiddleTableID", typeof(int)).AutoIncrement = true;
            tableMiddle.PrimaryKey = new DataColumn[] { tableMiddle.Columns["MiddleTableID"] };
            tableMiddle.Columns.Add("TopTableID", typeof(int));
            tableMiddle.Columns.Add("IntegerColumn", typeof(int));
            tableMiddle.Columns.Add("Flags", typeof(WarningFlag));
            for (int i = 0; i < 7; i++)
            {
                tableMiddle.Columns.Add(string.Format("StringColumn{0}", i), typeof(string)).DefaultValue = "TopTableID";
            }

            DataTable tableBottom = new DataTable("tableBottom");
            tableBottom.Columns.Add("BottomTableID", typeof(int)).AutoIncrement = true;
            tableBottom.PrimaryKey = new DataColumn[] { tableMiddle.Columns["BottomTableID"] };
            tableBottom.Columns.Add("MiddleTableID", typeof(int));
            tableBottom.Columns.Add("IntegerColumn", typeof(int));
            tableBottom.Columns.Add("Flags", typeof(WarningFlag));
            for (int i = 0; i < 7; i++)
            {
                tableBottom.Columns.Add(string.Format("StringColumn{0}", i), typeof(string)).DefaultValue = "tableBottom";
            }


            DataSet ds = new DataSet();
            ds.Tables.AddRange(new DataTable[] { tableTop, tableMiddle, tableBottom });

            ds.Relations.Add("TopMiddle", tableTop.Columns["TopTableID"], tableMiddle.Columns["TopTableID"]);
            ds.Relations.Add("MiddleBottom", tableMiddle.Columns["MiddleTableID"], tableBottom.Columns["MiddleTableID"]);

            Random rnd = new Random();
            for (int i = 0; i < 5000; i++)
            {
                DataRow topRow = tableTop.Rows.Add(null, rnd.Next(0, 10000), ((WarningFlag) (i % 2)));
                PopulateChild(topRow, ref tableMiddle, ref tableBottom);
            }


            return ds;
        }

        private void PopulateChild(DataRow topRow, ref DataTable tableMiddle, ref DataTable tableBottom)
        {
            Random rnd = new Random();
            DataRow middleRow = tableMiddle.Rows.Add(null, topRow[0], rnd.Next(0, 10000), ((WarningFlag)(tableMiddle.Rows.Count % 2)));
            int init = rnd.Next(1, 10);
            for (int i = 0; i < 320; i++)
            {
                tableBottom.Rows.Add(null, middleRow[0], init * i, ((WarningFlag)(i % 2)));
            }
        }

        private BindingList<DataObject> GetDataBinding()
        {
            BindingList<DataObject> retData = new BindingList<DataObject>();
            Random rnd = new Random();
            for (int i = 0; i < 5000; i++)
            {
                BindingList<DataObject> bottomChild = new BindingList<DataObject>();
                for (int j = 0; j < 320; j++)
                {
                    DataObject objBottom = new DataObject() { TableID = j, IntegerColumn = rnd.Next(0, 10000), Flags = ((WarningFlag)(j % 2)) };
                    bottomChild.Add(objBottom);
                }

                BindingList<DataObject> middleChild = new BindingList<DataObject>();
                DataObject objMiddle = new DataObject() { TableID = i, IntegerColumn = rnd.Next(0, 10000), Flags = ((WarningFlag)(i % 2)), Child = bottomChild };
                middleChild.Add(objMiddle);

                DataObject obj = new DataObject() { TableID = i, IntegerColumn = rnd.Next(0, 10000), Flags = ((WarningFlag)(i % 2)), Child = middleChild };
                retData.Add(obj);
            }

            return retData;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            button1.Enabled = false;
            button2.Enabled = true;
            button3.Enabled = true;
            DateTime now = DateTime.Now;
            listBox1.Items.Add(string.Format("Generating data starts at {0}", now));
            //ds = GetData();
            dataObjects = GetDataBinding();
            listBox1.Items.Add(string.Format("Generating data tooks {0}", (DateTime.Now - now)));
        }

        private void button2_Click(object sender, EventArgs e)
        {
            //if (ds == null)
            //    return;
            if (dataObjects == null)
                return;
            DateTime now = DateTime.Now;
            listBox1.Items.Add(string.Format("Setting UltraGrid1 DataSource starts at {0}", now));

            ultraGrid1.DataSource = dataObjects;
            listBox1.Items.Add(string.Format("Setting UltraGrid1 DataSource tooks {0}", (DateTime.Now - now)));
            ultraGrid1.DisplayLayout.Bands[0].SortedColumns.Add(ultraGrid1.DisplayLayout.Bands[0].Columns["IntegerColumn"], true);
        }

        private void ultraGrid1_InitializeRow(object sender, Infragistics.Win.UltraWinGrid.InitializeRowEventArgs e)
        {
            if ((WarningFlag)e.Row.Cells["Flags"].Value == WarningFlag.NoWarning)
                e.Row.Appearance.BackColor = Color.Red;
            else
                e.Row.Appearance.BackColor = Color.Yellow;
            
        }


        private void ultraGrid2_InitializeRow(object sender, Infragistics.Win.UltraWinGrid.InitializeRowEventArgs e)
        {
            if (e.ReInitialize)
                return;

            if ((int)e.Row.Cells[0].Value % 3 == 0)
            {
                e.Row.Appearance.BackColor = Color.Yellow;
                return;
            }

            if ((int)e.Row.Cells[0].Value % 4 == 0)
            {
                e.Row.Appearance.BackColor = Color.Green;
                return;
            }

            if ((int)e.Row.Cells[0].Value % 5 == 0)
            {
                e.Row.Appearance.BackColor = Color.Orange;
                return;
            }

            e.Row.Appearance.BackColor = Color.Azure;
        }

        private void ultraGrid1_MouseClick(object sender, MouseEventArgs e)
        {
            listBox1.Items.Add(string.Format("Click onto {0}", ((UltraGrid)sender).Name));
        }

        private void ultraGrid1_BeforeRowExpanded(object sender, CancelableRowEventArgs e)
        {
            
        }

        private void ultraGrid1_AfterRowExpanded(object sender, RowEventArgs e)
        {
            listBox1.Items.Add(string.Format("{1}Expand ends at {0}", DateTime.Now, ((UltraGrid)sender).Name));
           
        }

        

        private void ultraGrid1_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (dataObjects == null)
                return;
            DateTime now = DateTime.Now;
            listBox1.Items.Add(string.Format("Setting UltraGrid1 DataSource starts at {0}", now));

            ultraGrid2.DataSource = dataObjects;
            listBox1.Items.Add(string.Format("Setting UltraGrid1 DataSource tooks {0}", (DateTime.Now - now)));
            ultraGrid2.DisplayLayout.Bands[0].SortedColumns.Add(ultraGrid2.DisplayLayout.Bands[0].Columns["IntegerColumn"], true);
        }

        
    }
}
